// hashFnv1a64.ts
function hashFnv1a64(input: string): string {
  const FNV_PRIME_LOW = 0x1b3;
  const FNV_PRIME_HIGH = 0x1000000;
  let hashLow = 0x62b82175;
  let hashHigh = 0xcbf29ce4;

  for (let i = 0; i < input.length; i++) {
    const char = input.charCodeAt(i);

    // XOR low and high with char
    hashLow ^= char;

    // Multiply 64-bit hash by 64-bit prime (FNV_PRIME)
    const low = hashLow * FNV_PRIME_LOW;
    const high = hashLow * FNV_PRIME_HIGH + hashHigh * FNV_PRIME_LOW;

    hashLow = low >>> 0;
    hashHigh = high >>> 0;
  }

  // Combine high and low to hex string
  const highHex = hashHigh.toString(16).padStart(8, '0');
  const lowHex = hashLow.toString(16).padStart(8, '0');
  return highHex + lowHex;
}
